module Main where

import Alvis

-- 1)
-- definicje typow (jesli wystepuja)
-- definicje sa przekopiowane bezposrednio z pliku Alvis

-- 2)
-- definicje funkcji (jesli wystepuja)
-- definicje sa przekopiowane bezposrednio z pliku Alvis
-- UWAGA
-- instancje funkcji show powinny byc moim zdaniem
-- definiowane przez osobe projektujaca w model w Alvisie

-- 3)
-- lista nazw agentow
agents = ["A", "B", "C", "D"]

priorities = [0, 0, 0, 0]

modelsize :: Int
modelsize = 4 -- ???

-- 4)
-- definicje typow do opisu stanow poszczegolnych agentow
-- roznica w definicjach dotyczy wylacznie parametrow,
-- nazwy typow "Nazwa agenta" + "State"
type AState = (Mode, Int, [ContentsInfo], (Int))  
type BState = (Mode, Int, [ContentsInfo], (Int))
type CState = (Mode, Int, [ContentsInfo], (Int))  
type DState = (Mode, Int, [ContentsInfo], (Int))

-- 5)
-- definicja stanu modelu, ustalona tu kolejnosc
-- decyduje o tym jak beda opisywane wezly w grafie LTS
type State = (AState, BState, CState, DState)

  -- defincija (stala) wezla grafu: numer, stan, lista lukow wychodzacych
type Node = (Int, State, [(String, Int)])

-- 6)
-- definicja stanu poczatkowego
s0 :: State
s0 = ((X,1,[],(0)), (I,0,[],(0)), (W,0,[CIn "c1"],(0)), (W,0,[CIn "d1"],(0)))

-- 7)
-- definicja funkcji enable, ktora okresla aktywne przejscia
-- w zaleznosci od aktualnego stanu systemu,
-- wynik:
-- lista przejsc (typ TTransition z Alvis.hs):
-- kazde przejscie to: nazwa, nazwa agenta/portu(ewentualne informacje dodatkowe), numer instrukcji

-- funkcje pomocnicze
takeam :: Int -> State -> Mode
takeam 1 ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4))) = am1
takeam 2 ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4))) = am2
takeam 3 ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4))) = am3
takeam 4 ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4))) = am4

takepc :: Int -> State -> Int
takepc 1 ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4))) = pc1
takepc 2 ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4))) = pc2
takepc 3 ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4))) = pc3
takepc 4 ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4))) = pc4

takeci :: Int -> State -> [ContentsInfo]
takeci 1 ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4))) = ci1
takeci 2 ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4))) = ci2
takeci 3 ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4))) = ci3
takeci 4 ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4))) = ci4

-- stały kod
searchci :: ContentsInfo -> Int -> State -> Int
searchci x n s
  | n > modelsize = 0
  | elem x (takeci n s) = n
  | otherwise = searchci x (n + 1) s

-- wyszukuje numer agenta, który wywołał procedurę agenta o numerze k, w stanie s.
searchproc :: Int -> Int -> State -> Int  
searchproc k n s
  | n > modelsize = 0
  | (findproc a (takeci n s)) /= CProc "" = n
  | otherwise = searchproc k (n + 1) s
  where a = agents!!(k-1)  -- nazwa k-tego agenta

-- sprawdza czy kontekst agenta o numerze k w stanie s jest równy X  
xcontext :: Int -> State -> Bool
xcontext k s
  | takeam k s == X = True  -- agent aktywny
  | n /= 0 && takeam n s == T = xcontext n s
  | otherwise = (takeam n s) == X
  where n = searchproc k 1 s
--


----------------------------------------------------------------------------
enable :: State -> String -> [TTransition]

enable ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4))) "A"
  | am1 == X && pc1 == 1 = [TLoop "A" 1]
  | am1 == X && pc1 == 2 = [TExec "A(1)" 2, TExec "A(2)" 2]
  | am1 == X && pc1 == 3 = [TIf "A" 3]
  | am1 == X && pc1 == 4 = [TStart "A" 4]
  | am1 == X && pc1 == 5 && (procfree ci1) && am3 == W && elem (CIn "c1") ci3 && am4 == W && elem (CIn "d1") ci4 = [TOutAP "A.a1" "C.c1" 5, TOutAP "A.a1" "D.d1" 5]
  | am1 == X && pc1 == 5 && (procfree ci1) && am3 == W && elem (CIn "c1") ci3 = [TOutAP "A.a1" "C.c1" 5]
  | am1 == X && pc1 == 5 && (procfree ci1) && am4 == W && elem (CIn "d1") ci4 = [TOutAP "A.a1" "D.d1" 5]
  | am1 == X && pc1 == 5 && (procfree ci1) = [TOut "A.a1" 5]
  | am1 == X && pc1 == 6 && (procfree ci1) && am3 == W && elem (COut "c2") ci3 = [TInAP "A.a1" "C.c2" 6]
  | am1 == X && pc1 == 6 && (procfree ci1) = [TIn "A.a1" 6]
  | am1 == X && pc1 == 7 && not (am2 == X && pc2 == 2) = [TOut "A.a2" 7]
  | am1 == X && pc1 == 8 = [TExit "A" 8]
  | am1 == X && pc1 == 9 && am2 == X && pc2 == 3 = [TInAA "A.a2" "B.b2" 9]
  | am1 == X && pc1 == 9 = [TIn "A.a2" 9]
  | otherwise = []  
  
enable ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4))) "B"
  | am2 == X && pc2 == 1 = [TSelect "B" 1]
  | am2 == X && pc2 == 2 && am1 == X && pc1 == 7 = [TInAA "B.b2" "A.a2" 2]
  | am2 == X && pc2 == 2 = [TIn "B.b2" 2]
  | am2 == X && pc2 == 3 && not (am1 == X && pc1 == 9) = [TOut "B.b2" 3]
  | am2 == X && pc2 == 4 = [TExec "B" 4]
  | am2 == X && pc2 == 5 && (procfree ci2) && am4 == W && elem (CIn "d1") ci4 = [TOutAP "B.b1" "D.d1" 5]
  | am2 == X && pc2 == 5 && (procfree ci2) = [TOut "B.b1" 5]
  | am2 == X && pc2 == 6 = [TIf "B" 6]
  | am2 == X && pc2 == 7 = [TExec "B" 7]
  | am2 == X && pc2 == 8 = [TNull "B" 8]
  | am2 == X && pc2 == 9 = [TJump "B" 9]
  | otherwise = []    
  
enable ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4))) "C"
  | am3 == T && pc3 == 1 && (xcontext 3 s) = [TIn "C.c1" 1]
  | am3 == T && pc3 == 2 && (procfree ci3) && (xcontext 3 s) && am4 == W && elem (COut "d2") ci4 = [TInPP "C.c3" "D.d2" 2]
  | am3 == T && pc3 == 2 && (procfree ci3) && (xcontext 3 s) = [TIn "C.c3" 2]
  | am3 == T && pc3 == 3 && (xcontext 3 s) = [TOut "C.c2" 3]
  | am3 == T && pc3 == 4 && (xcontext 3 s) = [TExec "C" 4]
  | otherwise = []
  where s = ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4)))

enable ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4))) "D"
  | am4 == T && pc4 == 1 && (xcontext 4 s) = [TIn "D.d1" 1]
  | am4 == T && pc4 == 2 && (xcontext 4 s) = [TOut "D.d2" 2]
  | am4 == T && pc4 == 3 && (xcontext 4 s) = [TExec "D" 3]
  | otherwise = []
  where s = ((am1,pc1,ci1,(pv1)),(am2,pc2,ci2,(pv2)),(am3,pc3,ci3,(pv3)),(am4,pc4,ci4,(pv4)))

  
-- 7)
-- funkcja realizujaca przejscia TODO:
fire :: TTransition -> State -> State

fire (TLoop "A" 1) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,2,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TExec "A(1)" 2) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,3,ci1,1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TExec "A(2)" 2) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,3,ci1,2),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TIf "A" 3) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  | pv1 == 1  = ((am1,4,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  | otherwise = ((am1,8,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TStart "A" 4) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  | am2 == I  = ((am1,5,ci1,pv1),(X,1,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  | otherwise = ((am1,5,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TOutAP "A.a1" "C.c1" 5) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,pc1,ci1 ++ [CProc "C.c1"],pv1),(am2,pc2,ci2,pv2),(T,1,[],pv3),(am4,pc4,ci4,pv4))

fire (TOutAP "A.a1" "D.d1" 5) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,pc1,ci1 ++ [CProc "D.d1"],pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(T,1,[],pv4))

fire (TOut "A.a1" 5) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((W,pc1,ci1 ++ [COut "a1"],pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  
fire (TInAP "A.a1" "C.c2" 6) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,pc1,ci1 ++ [CProc "C.c2"],pv1),(am2,pc2,ci2,pv2),(T,2,[],pv3),(am4,pc4,ci4,pv4))

fire (TIn "A.a1" 6) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((W,pc1,ci1 ++ [CIn "a1"],pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TOut "A.a2" 7) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  | elem (CGuard) ci2 =  ((W,pc1,ci1 ++ [COut "a2"],pv1),(X,2,remove (CGuard) ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  | otherwise = ((W,pc1,ci1 ++ [COut "a2"],pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TExit "A" 8) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((F,0,[],pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TInAA "A.a2" "B.b2" 9) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,1,ci1,pv1),(am2,4,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TIn "A.a2" 9) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  | elem (CGuard) ci2 =  ((W,pc1,ci1 ++ [CIn "a2"],pv1),(X,3,remove (CGuard) ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  | otherwise = ((W,pc1,ci1 ++ [CIn "a2"],pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TSelect "B" 1) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  | elem (COut "a2") ci1 = ((am1,pc1,ci1,pv1),(am2,2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  | elem (CIn "a2") ci1 = ((am1,pc1,ci1,pv1),(am2,3,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  | otherwise = ((am1,pc1,ci1,pv1),(W,pc2,ci2 ++ [CGuard],pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TInAA "B.b2" "A.a2" 2) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,9,ci1,pv1),(am2,4,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TIn "B.b2" 2) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,pc1,ci1,pv1),(W,pc2,ci2 ++ [CIn "b2"],pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TExec "B" 4) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,pc1,ci1,pv1),(am2,5,ci2,(pv2 + 1)),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TOutAP "B.b1" "D.d1" 5) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,pc1,ci1,pv1),(am2,pc2,ci2 ++ [CProc "D.d1"],pv2),(am3,pc3,ci3,pv3),(T,1,ci4,pv4))

fire (TOut "B.b1" 5) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,pc1,ci1,pv1),(W,pc2,ci2 ++ [COut "b1"],pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TIf "B" 6) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  | pv2 == 3 = ((am1,pc1,ci1,pv1),(am2,7,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  | otherwise = ((am1,pc1,ci1,pv1),(am2,8,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TExec "B" 7) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,pc1,ci1,pv1),(am2,9,ci2,0),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TNull "B" 8) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,pc1,ci1,pv1),(am2,9,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  
fire (TJump "B" 9) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,pc1,ci1,pv1),(am2,4,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TIn "C.c1" 1) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  | pv1 == 0 = ((am1,6,remove (CProc "C.c1") ci1,pv1),(am2,pc2,ci2,pv2),(W,0,[CIn "c1"],pv1),(am4,pc4,ci4,pv4))
  | otherwise = ((am1,6,remove (CProc "C.c1") ci1,pv1),(am2,pc2,ci2,pv2),(W,0,[COut "c2"],pv1),(am4,pc4,ci4,pv4))

fire (TInPP "C.c3" "D.d2" 2) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3 ++ [CProc "D.d2"],pv3),(T,2,[],pv4))
  
fire (TIn "C.c3" 2) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((W,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3 ++ [CIn "c3"],pv3),(am4,pc4,ci4,pv4))

fire (TOut "C.c2" 3) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,pc1,ci1,pv3),(am2,pc2,ci2,pv2),(am3,4,ci3,pv3),(am4,pc4,ci4,pv4))

fire (TExec "C" 4) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  = ((am1,7,remove (CProc "C.c2") ci1,pv1),(am2,pc2,ci2,pv2),(W,0,[CIn "c1"],0),(am4,pc4,ci4,pv4))

fire (TIn "D.d1" 1) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  | elem (CProc "D.d1") ci1 && pv1 == 0 && elem (COut "b1") ci2 = ((am1,6,remove (CProc "D.d1") ci1,pv1),(X,pc2,ci2 ++ [CProc "D.d1"],pv2),(am3,pc3,ci3,pv3),(T,1,[],pv1))
  | elem (CProc "D.d1") ci1 && pv1 == 0 = ((am1,6,remove (CProc "D.d1") ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(W,0,[CIn "d1"],pv1))
  | elem (CProc "D.d1") ci1 = ((am1,6,remove (CProc "D.d1") ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(W,0,[COut "d2"],pv1))
  | elem (CProc "D.d1") ci2 && pv2 == 0 && elem (COut "a1") ci1 = ((X,pc1,ci1 ++ [CProc "D.d1"],pv1),(am2,6,remove (CProc "D.d1") ci2,pv2),(am3,pc3,ci3,pv3),(T,1,[],pv2))
  | elem (CProc "D.d1") ci2 && pv2 == 0 = ((am1,pc1,ci1,pv1),(am2,6,remove (CProc "D.d1") ci2,pv2),(am3,pc3,ci3,pv3),(W,0,[CIn "d1"],pv1))
  | elem (CProc "D.d1") ci2 = ((am1,pc1,ci1,pv1),(am2,6,remove (CProc "D.d1") ci2,pv2),(am3,pc3,ci3,pv3),(W,0,[COut "d2"],pv1))

fire (TIn "D.d2" 2) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  | elem (CProc "D.d1") ci1 = ((am1,pc1,ci1,pv4),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,3,ci4,pv4))
  | elem (CProc "D.d1") ci2 = ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv4),(am3,pc3,ci3,pv3),(am4,3,ci4,pv4))

fire (TExec "D" 3) ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4))
  | elem (CProc "D.d1") ci1 && elem (COut "b1") ci2 = ((am1,6,remove (CProc "D.d2") ci1,pv1),(X,pc2,ci2 ++ [CProc "D.d1"],pv2),(am3,pc3,ci3,pv3),(T,1,[],0))
  | elem (CProc "D.d1") ci1 = ((am1,6,remove (CProc "D.d2") ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(W,0,[CIn "d1"],0))
  | elem (CProc "D.d1") ci2 && elem (COut "a1") ci1 = ((X,pc1,ci1 ++ [CProc "D.d1"],pv1),(am2,6,remove (CProc "D.d2") ci2,pv2),(am3,pc3,ci3,pv3),(T,1,[],0))
  | elem (CProc "D.d1") ci2 = ((am1,pc1,ci1,pv1),(am2,6,remove (CProc "D.d2") ci2,pv2),(am3,pc3,ci3,pv3),(W,0,[CIn "d1"],0))

-- TODO: Jak wygląda opis guard w artykule (czy nie został pominięty)?
        
-- dla testów poprawności  
fire _ _ = ((F,0,[],0), (F,0,[],0), (F,0,[],0), (F,0,[],0))

-- ******************************************************************
-- constant piece of code

-- Function provides the list of all transition potentially enable in the given state.
--
enableInState :: State -> [TTransition]
enableInState s = foldr (++) [] (map (enable s) agents)

-- Function provides the list of all transition enable in the given state.
-- UWAGA: ponizsza wersja dotyczy tylko modeli bez czasu
-- 
enableTransitions :: State -> [TTransition]
enableTransitions = enableInState

-- Function searches the list for a state. 
--
findState :: State -> [Node] -> Int
findState _ [] = -1
findState z ((n,s,t):nodes) | z == s = n
                            | otherwise = findState z nodes        

-- Function generates the LTS graph
--
-- lista wezlow do przetworzenia, 
-- lista aktywnych przejsc w pierwszym wezle do przetworzenia
-- lista kontrolna niezbedna do rekurencji
--
ltsgen :: [Node] -> [TTransition] -> [Node] -> [Node]

ltsgen ((n,s,ls):nodes) (t:ts) list
  | ind == -1 = ltsgen ([(n,s,ls ++ [((show t),(lastn+1))])] ++ nodes ++ [((lastn+1),state,[])]) ts newList
  | otherwise = ltsgen ([(n,s,ls ++ [((show t),ind)])] ++ nodes) ts list
  where state = fire t s
        ind = findState state list
        (lastn,lasts,lastls) = last ((n,s,ls):nodes)
        newList = list ++ [((lastn+1),state,[])]  

ltsgen ((n1,s1,l1):(n2,s2,l2):nodes) [] list  
  = (n1,s1,l1) : ltsgen ((n2,s2,l2):nodes) (enableTransitions s2) list    

ltsgen [(n,s,t)] [] _ = [(n,s,t)]          

lts = ltsgen [(0,s0,[])] (enableTransitions s0) [(0,s0,[])]

-- ((n,s,ls):nodes) to lista stanów, które zostały nam do przetworzenia
-- (t:ts) to lista aktywnych przejść dla stanu w pierwszym węźle
-- list jest listą kontrolną wszystkich stanów i służy do sprawdzania,
-- czy graf LTS zawiera już nowowyliczony węzeł, czy nie.
-- 
-- węzeł w grafie (n,s,ls) zawiera informacje o numerze węzła (n), stanie (s)
-- i listę krawędzi (ls). W linii 293 wyliczamy wynik wykonania tranzycji t
-- dla stanu s. Zmienna list zawiera listę wszystkich stanów. W linii 294
-- sprawdamy, czy nowowyznaczony stan jest na tej liście, czy nie ma.
-- W linii 295 wyszukujemy ostatni element na liście list. Jest to potrzebne 
-- do poprawnego numerowania stanów. 
-- Jeżeli nowowyznaczonego stanu nie ma na liście list (linia 291), to 
-- do listy krawędzi ls stanu, którym się aktualnie zajmowaliśmy dodajemy
-- nową krawędź [((show t),(lastn+1))] i do listy stanów do przetworzenia
-- dodajemy nowy stan [((lastn+1),state,[])]. Ten sam stan jest dodawany
-- do listy list (linia 293). Przy wywołaniu rekurencyjnym w linii 291
-- mamy już jedną tranzycję mniej do obsłużenia, ale dłuższą listę węzłów.
-- Jeżeli w linii 294 stwierdzimy, że taki stan już isnieje, to dodajemy
-- tylko połączenie do tego stanu [((show t),ind)])], a listy stanów
-- do przetworzenia i lista wszystkich stanów się nie zmieniają.
-- 
-- Linia 298, to przypadek, gdy lista tranzycji do przetworzenia jest pusta.
-- Rekurencyjnie przetwarzamy kolejny stan, a listę aktywnych przejść
-- dla tego stanu wyznaczamy z użyciem funkcji enableTransitions.
-- Linia 301, to zakończenie rekurencji, gdy dla ostatniego stanu na liście
-- stanów do przetworzenia nie ma już żadnych tranzycji do obsługi.


-- type Node = (Int, State, [(String, Int)])
---------------------------------------------------------------------

-- funkcje do drukowania LTS w formacie tekstowym

printTransitions :: [(String,Int)] -> String
printTransitions [] = []
printTransitions ((label,number):transitions) 
  = "-- " ++ label ++ " -> " ++ (show number) ++ "\n" ++ printTransitions transitions
  
printLTS :: [Node] -> String
printLTS [] = []
printLTS ((n, ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4)),ls):nodes) = 
  "\n" ++ (show n)
  ++ "\nA: (" ++ (show am1) ++ "," ++ (show pc1) ++ "," ++ (show ci1) ++ "," ++ (show pv1) ++")" 
  ++ "\nB: (" ++ (show am2) ++ "," ++ (show pc2) ++ "," ++ (show ci2) ++ "," ++ (show pv2) ++")" 
  ++ "\nC: (" ++ (show am3) ++ "," ++ (show pc3) ++ "," ++ (show ci3) ++ "," ++ (show pv3) ++")" 
  ++ "\nD: (" ++ (show am4) ++ "," ++ (show pc4) ++ "," ++ (show ci4) ++ "," ++ (show pv4) ++")\n" ++
  printTransitions ls ++ printLTS nodes 

-------- DOT ---------------------------------------------------------------

printDOT :: [Node] -> String
printDOT nl = "digraph G {\n\t rankdir=TB;\n" 
	++ dumpDOTNodes nl ++ dumpDOTtrans nl ++ "}\n"

dumpDOTNodes :: [Node] -> String
dumpDOTNodes [] = []
dumpDOTNodes ((n, ((am1,pc1,ci1,pv1),(am2,pc2,ci2,pv2),(am3,pc3,ci3,pv3),(am4,pc4,ci4,pv4)), ls):nodes)
  = "\t" ++ (show n) 
  ++ " [label = \"" ++ "(" ++ (show n) ++ ")"
  ++ "\\nA: (" ++ (show am1) ++ "," ++ (show pc1) ++ "," ++ (show ci1) ++ "," ++ (show pv1) ++")" 
  ++ "\\nB: (" ++ (show am2) ++ "," ++ (show pc2) ++ "," ++ (show ci2) ++ "," ++ (show pv2) ++")" 
  ++ "\\nC: (" ++ (show am3) ++ "," ++ (show pc3) ++ "," ++ (show ci3) ++ "," ++ (show pv3) ++")" 
  ++ "\\nD: (" ++ (show am4) ++ "," ++ (show pc4) ++ "," ++ (show ci4) ++ "," ++ (show pv4) ++")"     
	++ "\" shape=box];\n" 
	++ dumpDOTNodes nodes

dumpDOTtrans :: [Node] -> String
dumpDOTtrans [] = []
dumpDOTtrans (n:ns) = dumpSingleTrans n ++ dumpDOTtrans ns

dumpSingleTrans :: Node -> String
dumpSingleTrans (n,_,tl) = dumpTR (n,tl)

dumpTR :: (Int,[(String,Int)]) -> String
dumpTR (_,[]) = []
dumpTR (n,(f,x):ts) = "\t" ++ (show n) ++ " -> " ++ (show x) 
		++ " [label = \"" ++ f ++ "\"];\n"
		++ dumpTR (n,ts)

-- ALD ---------------------------------------------------------------

printALD :: [Node] -> String
printALD nl = "des (0," ++ show (countTransitions(0, nl)) ++ "," ++ show (length nl) ++ ")\n" 
         ++ dumpALDtrans nl 
-- printALD nl = dumpALDtrans nl 

countTransitions :: (Int,[Node]) -> Int
countTransitions (cnt,[]) = cnt
countTransitions (cnt,(n, (a1,a2,a3,a4), t):ns)= countTransitions(cnt+countT(t),ns)

countT :: [(string,Int)] -> Int
countT [] = 0
countT ((f,n):ts) = 1 + countT ts

dumpALDtrans :: [Node] -> String
dumpALDtrans [] = []
dumpALDtrans (n:ns) = dumpSingleTransALD n ++ dumpALDtrans ns

dumpSingleTransALD :: Node -> String
dumpSingleTransALD (n,_,tl) = dumpTRALD (n,tl)

dumpTRALD :: (Int,[(String,Int)]) -> String
dumpTRALD (_,[]) = []
dumpTRALD (n,(f,x):ts) = 	"(" ++ 
			(show n) ++
			"," ++
			(show f) ++
			"," ++ 
			(show x) ++ 
			")\n" ++
			dumpTRALD (n,ts)

showWL :: [String] -> String
showWL [] = "[]"
showWL (we:[]) = "[" ++ we ++"]"
showWL (we:ws) = "[" ++ we ++ "," ++ "]"

-- main ---------------------------------------------------------------

main = do 
--  putStrLn (printDOT lts)
  putStrLn (printALD lts)
--  putStrLn (printLTS lts)
  
